freeslot(
	"MT_POPCORN", "S_POPCORN",
	"MT_POPCORN_EMPTY", "S_POPCORN_EMPTY",
	"MT_POPCORNCRUMB", "S_POPCORNCRUMB",
	"SPR_POPC", "sfx_popeat",

	"MT_SODA", "S_SODA", "sfx_sip1", "sfx_sip2",

	"MT_CRAWLAPLUSHIE", "S_CRAWLAPLUSHIE",

	"MT_UGLYKNUX", "S_UGLYKNUX", "SPR_UGLY",

	"SPR_THNG"
)


local numcrumbs = 0


function theater.checkCrumbs()
	if numcrumbs < 512 then return end

	local removalchance = FixedDiv(numcrumbs - 512 * 3/4, numcrumbs)

	local crumbstoremove = {}
	for mo in mobjs.iterate() do
		if mo.type == MT_POPCORNCRUMB and P_RandomChance(removalchance) then
			crumbstoremove[#crumbstoremove + 1] = mo
		end
	end

	for i = 1, #crumbstoremove do
		P_RemoveMobj(crumbstoremove[i])
	end
end


addHook("MobjSpawn", function(mo)
	mo.theater_quantity = 10
end, MT_POPCORN)

addHook("MobjSpawn", function(mo)
	mo.frame = P_RandomRange(D, F)
	mo.oldmomz = 0

	numcrumbs = $ + 1
end, MT_POPCORNCRUMB)

addHook("MobjRemoved", function(mo)
	numcrumbs = $ - 1
end, MT_POPCORNCRUMB)

addHook("MobjThinker", function(mo)
	if mo.oldmomz < FU then return end

	if mo.momz <= 0 and P_IsObjectOnGround(mo) then
		mo.momz = -mo.oldmomz / 2
	end

	mo.oldmomz = mo.momz
end, MT_POPCORNCRUMB)

addHook("MobjSpawn", function(mo)
	mo.theater_quantity = 10
end, MT_SODA)

addHook("NetVars", function(net)
	numcrumbs = net($)
end)
